<script>

import { openDB } from 'idb';

import formGenerator from './components/FormGenerator.vue';
import ficheObjet from './components/FicheObjet.vue';

export default {
    // el: '#sysmaOffline',

    /******************************
     * The attribute components lists the different Vue components used in the current component
    ******************************/
    components: {
        formGenerator,
        ficheObjet,
    },

    /******************************
     * The method data() lists the different Vue variables used in the current component.
     * They must be called by this._variable_ in the section <script> and they must be called just _variable_ in the section <template>
    ******************************/
    data() {
        return {
            showCreateObjectForm: false,
            showParametersForm: false,
            showFicheObjet: false,
            showCorrigerFicheObjet: false,
            ficheObjetThesaurus: null,
            ficheObjetFeature: null,
            inputsListParametersForm: null,
            // inputsListCreateObjectForm: [
            //     { type: "textChoiceType", label: "Type d'objet", name: "sysma_object_type_id", id: "sysma_object_type_id_input", options: [] },
            //     { type: "textType", label: "Nom de l'objet", name: "sysma_object", id: "sysma_object_input" },
            //     {
            //         type: "textChoiceType", label: "Statut", name: "status", id: "status_input", options: [{
            //             optionName: "Préconisé - prévu dans une programmation",
            //             optionValue: "preconise", selected: false
            //         },
            //         {
            //             optionName: "1er contact - 1er échange avec l'exploitant sans avoir fixé les détails",
            //             optionValue: "1ercontact", selected: false
            //         },
            //         {
            //             optionName: "En préparation - les détails de l'objet sont définis",
            //             optionValue: "en_preparation", selected: false
            //         },
            //         {
            //             optionName: "Existant - l'objet existe, son installation est terminée",
            //             optionValue: "existant", selected: true
            //         },
            //         {
            //             optionName: "Annulé - l'objet était prévu mais il a été annulé",
            //             optionValue: "annule", selected: false
            //         }]
            //     },
            //     { type: "dateType", label: "Date de création (ou d'installation)", name: "start_date", id: "dateCreation_input", isCreationDate: true },
            //     { type: "dateType", label: "Date de fin (ou de suppression, disparition)", name: "end_date", id: "end_date_input", isCreationDate: false },
            //     {
            //         type: "textChoiceType", label: "Structure", name: "organisation_id", id: "organisation_id_input", options: [{
            //             optionName: "Etablissement Public Territorial du Bassin de la Sevre-Nantaise",
            //             optionValue: "1", selected: true
            //         },
            //         {
            //             optionName: "Non renseigné",
            //             optionValue: "3", selected: false
            //         },
            //         {
            //             optionName: "Pas de structure",
            //             optionValue: "2", selected: false
            //         }]
            //     }
            // ],
            inputsListCreateObjectForm: [],
            inputsListCorrigerFicheObjetForm: null,
            createObjectFormValues: {},
            parametersFormValues: {},
            objectTypesList: {},
            sysmaOrgLabel: '',
            // WARNING : Be aware that those values are updated at some precise times by some buttons, then be carefull
            // where to use them in the code. They come from some hidden
            ficheObjetObjectTypeID: null,
            ficheObjetObjectID: null,
            creerObjetObjectTypeID: null
        }
    },


    /******************************
     * The attribute methos lists the different Vue methods used in the current component.
     * They must be called by this._method_ in the section <script> and they must be called just _method_ in the section <template>
    ******************************/
    methods: {
        /******************************
         * Returns true if and only if the two arrays contain the same set of elements (in any order)
         * @param {Array} array1 
         * @param {Array} array2 
         ******************************/
        arraysEquals(array1, array2) {
            if (array1.length !== array2.length) {
                return false;
            }
            else {
                for (let i = 0; i < array1.length; i++) {
                    if (!array2.includes(array1[i])) {
                        return false;
                    }
                }
                return true;
            }
        },
        /******************************
         * Returns if two parameters are equal (can take null, undefined, Array, String, Number as inputs)
         * @param {*} param1 
         * @param {*} param2 
         ******************************/
        paramsEquals(param1, param2) {
            if (Array.isArray(param1)) {
                return this.arraysEquals(param1, param2);
            } else if ((param1 === undefined || param1 === null) && (param2 === undefined || param2 === null)) {
                return true;
            } else {
                return param1 === param2;
            }
        },



        /******************************
         * Creates an Array containing the description of the inputs for the creation of an object. It bases itself on the offlineInitData provided by the server and store locally in IndexedDB
         ******************************/
        async initializeCreateObjectForm() {
            const sysmaAppStateDB = await openDB('sysmaAppStateDB');
            let isOffline = (await sysmaAppStateDB.get('state', 'isOffline')).value;

            if (isOffline) {
                let offlineInitData = (await sysmaAppStateDB.get('state', 'offlineInitData')).value;
                let objectTypeName = offlineInitData.layerIds[this.creerObjetObjectTypeID.toString()];

                if (!(this.creerObjetObjectTypeID === null)) {
                    this.inputsListCreateObjectForm = [];

                    this.inputsListCreateObjectForm.push(
                        { type: "textChoiceType", label: "Type d'objet", name: "sysma_object_type_id", id: "sysma_object_type_id_input", options: [
                            { optionValue: this.creerObjetObjectTypeID, optionName: objectTypeName, selected: true}
                        ] }
                    );

                    this.inputsListCreateObjectForm.push(
                        { type: "textType", label: "Nom de l'objet", name: "sysma_object", id: "sysma_object_input" }
                    );

                    this.inputsListCreateObjectForm.push(
                        {type: "textChoiceType", label: "Statut", name: "status", id: "status_input", options: []}
                    );
                    for (let status of offlineInitData.statusLabels) {
                        this.inputsListCreateObjectForm[2].options.push(
                            {optionName: status.status, optionValue: status.status_value, selected: (status.status_value == 'existant')}
                        );
                    }

                    this.inputsListCreateObjectForm.push(
                        { type: "dateType", label: "Date de création (ou d'installation)", name: "start_date", id: "dateCreation_input", isCreationDate: true }
                    );

                    this.inputsListCreateObjectForm.push(
                        { type: "dateType", label: "Date de fin (ou de suppression, disparition)", name: "end_date", id: "end_date_input", isCreationDate: false }
                    );

                    this.inputsListCreateObjectForm.push(
                        {type: "textChoiceType", label: "Structure", name: "organisation_id", id: "organisation_id_input", options: []}
                    );
                    for (let org of offlineInitData.orgLabels) {
                        this.inputsListCreateObjectForm[5].options.push(
                            {optionName: org.organisation,optionValue: org.organisation_id, selected: (org.organisation_id == 1)}
                        );
                    }

                    // this.inputsListCreateObjectForm[0].options = [{
                    //     optionValue: this.creerObjetObjectTypeID,
                    //     optionName: this.objectTypesList[this.creerObjetObjectTypeID.toString()],
                    //     selected: true
                    // }];
                }
                // console.log(this.inputsListCreateObjectForm);

                this.showParametersForm = false;
                this.showCorrigerFicheObjet = false;
                this.showFicheObjet = false;
                this.showCreateObjectForm = true;
            }
        },

        /******************************
         * Creates an Array containing the description of the inputs for the modification of an object (fiche objet).
         ******************************/
        async initializeCorrigerFicheObjet() {
            await this.initializeCreateObjectForm();

            this.inputsListCorrigerFicheObjetForm = JSON.parse(JSON.stringify(this.inputsListCreateObjectForm)).slice(1);

            this.inputsListCorrigerFicheObjetForm[0].parameterValue = this.ficheObjetFeature.properties.name;

            for (const opt of this.inputsListCorrigerFicheObjetForm[1].options) {
                opt.selected = (opt.optionValue === this.ficheObjetFeature.properties.status);
            }

            this.inputsListCorrigerFicheObjetForm[2].parameterValue = this.ficheObjetFeature.properties.startDate;
            this.inputsListCorrigerFicheObjetForm[3].parameterValue = this.ficheObjetFeature.properties.endDate;

            for (const opt of this.inputsListCorrigerFicheObjetForm[4].options) {
                opt.selected = (opt.optionValue.toString() === this.ficheObjetFeature.properties.organisation_id.toString());
            }

            // console.log("correction fiche objet : ", this.inputsListCorrigerFicheObjetForm);

            this.showFicheObjet = false;
            this.showCreateObjectForm = false;
            this.showParametersForm = false;
            this.showCorrigerFicheObjet = true;
        },

        /******************************
         * Function that gets the informations of the object being created / modified / consulted that are stored in the corresponding hidden <input> tag.
         * This method is called each time we simulate a click on the corresponding <input> tag.
         ******************************/
        updateData() {
            this.ficheObjetObjectTypeID = parseInt(document.getElementById('fiche-objet-type-id').value);
            this.ficheObjetObjectID = parseInt(document.getElementById('fiche-objet-id').value);
            this.creerObjetObjectTypeID = parseInt(document.getElementById('creer-objet-type-id').value);
        },



        /******************************
         * We split into two steps the creation of an object and filling its parameters like in the 'normal' version of Sysma.
         ******************************/
        /******************************
         * Creates the geoJSON of the object and adds it to the FeatureCollection so that it appears on the map.
         ******************************/
        async createObject() {
            let geoJSON = { type: "Feature", };

            const sysmaDictDB = await openDB('sysmaDictDB');
            let thesaurus = (await sysmaDictDB.get('dictionnaires', this.creerObjetObjectTypeID)).data;

            const sysmaAppStateDB = await openDB('sysmaAppStateDB');
            let geom = (await sysmaAppStateDB.get('state', 'objectGeomBeingCreated')).value;
            if (geom.substring(geom.length - 22) === "geometry_type=ST_Point") {
                let coordinates = geom.substring(5, geom.length - 22).split(",");
                if (thesaurus.geometry_type === "ST_Point") {
                    geoJSON.geometry = { type: "Point", coordinates: [parseFloat(coordinates[0]), parseFloat(coordinates[1])] };
                } else if (thesaurus.geometry_type === "ST_Linestring") {
                    geoJSON.geometry = { type: "LineString", coordinates: [] };
                    for (let i = 0; i < coordinates.length / 2; i++) {
                        geoJSON.geometry.coordinates.push([parseFloat(coordinates[2 * i]), parseFloat(coordinates[2 * i + 1])]);
                    }
                } else if (thesaurus.geometry_type === "ST_Polygon") {
                    geoJSON.geometry = { type: "Polygon", coordinates: [[]] };
                    for (let i = 0; i < coordinates.length / 2; i++) {
                        geoJSON.geometry.coordinates[0].push([parseFloat(coordinates[2 * i]), parseFloat(coordinates[2 * i + 1])]);
                    }
                }
            }

            geoJSON.style = thesaurus.style_decode;

            let objectID = (await sysmaAppStateDB.get('state', 'objectIDBeingCreated')).value;
            await sysmaAppStateDB.put('state', { parameterName: 'objectIDBeingCreated', value: objectID + 1 });

            // let date = new Date(); date = date.toISOString(); date = date.substring(0,10)+" "+date.substring(11,23)+"000";
            // let properties = {name: this.createObjectFormValues.sysma_object, type: "objet", layer_id: "layer_object_type" + this.creerObjetObjectTypeID,
            //                   type_geom: "ST_Point", object_type: thesaurus.sysma_object_type, id: "o" + objectID, startDate: this.createObjectFormValues.start_date,
            //                   endDate: this.createObjectFormValues.end_date, value: null, createdAt: date, createdBy: "", modifiedAt: date, modifiedBy: "",
            //                   organisation: "Etablissement Public Territorial du Bassin de la Sevre-Nantaise", status: this.createObjectFormValues.status,
            //                   offline_status: "created"};
            let properties = {
                name: this.createObjectFormValues.sysma_object || "", type: "objet", layer_id: "layer_object_type" + this.creerObjetObjectTypeID,
                type_geom: thesaurus.geometry_type, object_type: thesaurus.sysma_object_type, id: "f" + objectID,
                startDate: this.createObjectFormValues.start_date, endDate: this.createObjectFormValues.end_date,
                organisation_id: this.createObjectFormValues.organisation_id, status: this.createObjectFormValues.status,
                offline_status: "object_created"
            };

            geoJSON.properties = properties;

            console.log("createObject result : ", geoJSON);

            const sysmaLayersDB = await openDB('sysmaLayersDB');
            let layer = await sysmaLayersDB.get('layers', this.creerObjetObjectTypeID);
            layer.data.features.push(geoJSON);
            await sysmaLayersDB.put('layers', layer);

            this.createObjectFormValues = {};

            document.getElementById('fiche-objet-id').setAttribute('value', objectID);
            document.getElementById('fiche-objet-type-id').setAttribute('value', this.creerObjetObjectTypeID);
            document.getElementById('fiche-objet-id').click();

            await this.ficheObjet();
            await this.initializeTabMode();

            document.getElementById("layerobjecttype" + this.creerObjetObjectTypeID + "LayerController").click();
            document.getElementById("layerobjecttype" + this.creerObjetObjectTypeID + "LayerController").click();
        },

        /******************************
         * Creates the geoJSON.properties.parameters object, it allows to give each parameter a new value.
         * Besides, in order to explicitly store the actions of the user it puts a offline_status tag in the geoJSON in order to know if the user is making an update (added),
         * a modification (modified) or a creation (created).
         ******************************/
        async fillParameters() {
            const sysmaLayersDB = await openDB('sysmaLayersDB');
            let layer = await sysmaLayersDB.get('layers', this.ficheObjetObjectTypeID);

            let objectIndex = layer.data.features.length - 1;
            while ((objectIndex >= 0) && (!(parseInt(layer.data.features[objectIndex].properties.id.substring(1)) === this.ficheObjetObjectID))) {
                objectIndex--;
            }

            const sysmaDictDB = await openDB('sysmaDictDB');
            let thesaurus = (await sysmaDictDB.get('dictionnaires', this.ficheObjetObjectTypeID)).data;

            if (objectIndex < 0) {
                console.log('ERREUR : la feature n\'a pas été trouvée !');
            } else {
                let offlineCreatedObject = false;
                if (layer.data.features[objectIndex].properties.parameters === undefined) { offlineCreatedObject = true; layer.data.features[objectIndex].properties.parameters = []; }

                let startDate = this.parametersFormValues.tabModeStartDate;
                for (let k = 0; k < thesaurus.paramArray.length; k++) {
                    let param = thesaurus.paramArray[k];
                    if (offlineCreatedObject) {
                        let currentParam = {
                            id: param.parameter_id, dataType: param.data_type,
                            createdAt: param.created_at, modifiedAt: param.modified_at,
                            startDate: startDate, endDate: "0", offline_status: 'created'
                        };
                        if (Array.isArray(this.parametersFormValues[param.parameter_id + '_paramInput'])) {
                            currentParam.value = JSON.parse(JSON.stringify(this.parametersFormValues[param.parameter_id + '_paramInput']));
                            let choicesArray = {};
                            for (const i of Object.keys(param.choicesArray)) {
                                choicesArray[param.choicesArray[i].display_order.toString()] = {
                                    choice_id: param.choicesArray[i].choice_id, nom: param.choicesArray[i].nom,
                                    description: param.choicesArray[i].description, display_order: param.choicesArray[i].display_order, value_type: param.choicesArray[i].value_type
                                };
                            }
                            currentParam.choicesArray = choicesArray;
                        } else { currentParam.value = this.parametersFormValues[param.parameter_id + '_paramInput']; }
                        if ((currentParam.value === undefined) || (currentParam.value == null)) {
                            currentParam.value = "";
                        }
                        layer.data.features[objectIndex].properties.parameters.push(currentParam);
                    } else {
                        console.log(param.parameter_id + '_paramInput', this.paramsEquals(layer.data.features[objectIndex].properties.parameters[k].value, this.parametersFormValues[param.parameter_id + '_paramInput']))
                        if (!this.paramsEquals(layer.data.features[objectIndex].properties.parameters[k].value, this.parametersFormValues[param.parameter_id + '_paramInput'])) {
                            if (this.parametersFormValues[param.parameter_id + '_paramInput'] === null || this.parametersFormValues[param.parameter_id + '_paramInput'] === undefined) {
                                // Nothing we do not add an offline status to the object
                            } else {
                                if (this.parametersFormValues[param.parameter_id + '_paramInput' + 'OfflineStatus'] === 'potentially_created_or_modified') {
                                    if (layer.data.features[objectIndex].properties.parameters[k].offline_status !== 'created') {
                                        layer.data.features[objectIndex].properties.parameters[k].offline_status = 'modified';
                                    }
                                } else {
                                    layer.data.features[objectIndex].properties.parameters[k].offline_status = 'added';
                                }
                            }
                            if (Array.isArray(this.parametersFormValues[param.parameter_id + '_paramInput'])) {
                                layer.data.features[objectIndex].properties.parameters[k].value = JSON.parse(JSON.stringify(this.parametersFormValues[param.parameter_id + '_paramInput']));
                            } else {
                                layer.data.features[objectIndex].properties.parameters[k].value = this.parametersFormValues[param.parameter_id + '_paramInput'];
                            }
                        }
                    }
                }

                if ((!layer.data.features[objectIndex].properties.offline_status) && (!offlineCreatedObject)) { layer.data.features[objectIndex].properties.offline_status = 'param_modified'; }

                await sysmaLayersDB.put('layers', layer);
            }
            console.log('fillParameters result : ', layer.data.features[objectIndex]);
            this.parametersFormValues = {};
        },

        // async fillParameters() {
        //   const sysmaLayersDB = await openDB('sysmaLayersDB');
        //   let layer = await sysmaLayersDB.get('layers', this.ficheObjetObjectTypeID);

        //   let objectIndex = layer.data.features.length-1;
        //   while ((objectIndex >=0) && (!(parseInt(layer.data.features[objectIndex].properties.id.substring(1)) === this.ficheObjetObjectID))) {
        //     objectIndex--;
        //   }

        //   const sysmaDictDB = await openDB('sysmaDictDB');
        //   let thesaurus = (await sysmaDictDB.get('dictionnaires', this.ficheObjetObjectTypeID)).data;

        //   if (objectIndex < 0) {
        //     console.log('ERREUR : la feature n\'a pas été trouvée !');
        //   } else {
        //     layer.data.features[objectIndex].properties.parameters = [];

        //     let startDate = this.parametersFormValues.tabModeStartDate;
        //     for (const param of thesaurus.paramArray) {
        //       let currentParam = {id: param.parameter_id, dataType: param.data_type,
        //         createdAt: param.created_at, modifiedAt: param.modified_at,
        //         startDate: startDate, endDate: "0"};
        //       if (Array.isArray(this.parametersFormValues[param.parameter_alias])) {
        //         currentParam.value = JSON.parse(JSON.stringify(this.parametersFormValues[param.parameter_alias]));
        //         let choicesArray = {};
        //         for (const i of Object.keys(param.choicesArray)) {
        //           choicesArray[param.choicesArray[i].display_order.toString()] = {choice_id: param.choicesArray[i].choice_id, nom: param.choicesArray[i].nom,
        //             description: param.choicesArray[i].description, display_order: param.choicesArray[i].display_order, value_type: param.choicesArray[i].value_type};
        //         }
        //         currentParam.choicesArray = choicesArray;
        //       } else { currentParam.value = this.parametersFormValues[param.parameter_alias]; }
        //       layer.data.features[objectIndex].properties.parameters.push(currentParam);
        //     }

        //     if (layer.data.features[objectIndex].properties.offline_status !== 'object_created') {
        //       layer.data.features[objectIndex].properties.offline_status = 'param_modified';
        //     }

        //     await sysmaLayersDB.put('layers', layer);
        //   }
        //   console.log('fillParameters result : ', layer.data.features[objectIndex]);
        //   this.parametersFormValues = {};
        // },

        /******************************
         * Function that modifies the "fiche objet" data in the geoJSON
         ******************************/
        async modifieFicheObjet() {
            const sysmaLayersDB = await openDB('sysmaLayersDB');
            let layer = await sysmaLayersDB.get('layers', this.ficheObjetObjectTypeID);

            let objectIndex = layer.data.features.length - 1;
            while ((objectIndex >= 0) && (!(parseInt(layer.data.features[objectIndex].properties.id.substring(1)) === this.ficheObjetObjectID))) {
                objectIndex--;
            }

            if (objectIndex < 0) {
                console.log('ERREUR : la feature n\'a pas été trouvée !');
            } else {
                if (layer.data.features[objectIndex].properties.offline_status !== 'object_created') {
                    layer.data.features[objectIndex].properties.offline_status = 'object_modified';
                }
                layer.data.features[objectIndex].properties.name = this.createObjectFormValues.sysma_object;
                layer.data.features[objectIndex].properties.startDate = this.createObjectFormValues.start_date;
                layer.data.features[objectIndex].properties.endDate = this.createObjectFormValues.end_date;
                if (this.createObjectFormValues.status) {
                    layer.data.features[objectIndex].properties.status = this.createObjectFormValues.status;
                }
                if (this.createObjectFormValues.organisation_id) {
                    layer.data.features[objectIndex].properties.organisation_id = this.createObjectFormValues.organisation_id;
                }

                await sysmaLayersDB.put('layers', layer);
                console.log('modifieFicheObjet result : ', layer.data.features[objectIndex]);
            }

            this.createObjectFormValues = {};

            this.ficheObjet();
        },

        /******************************
         * Function that modifies the geometry of a Sysma object (in IndexedDB) and refreshes the layer displayed on the map
         ******************************/
        async editGeometry() {
            let geom = document.getElementById('geoEditGeomData').value;
            console.log('editGeom geometry : ', geom);
            const sysmaLayersDB = await openDB('sysmaLayersDB');
            let layer = await sysmaLayersDB.get('layers', this.ficheObjetObjectTypeID);

            let objectIndex = layer.data.features.length - 1;
            while ((objectIndex >= 0) && (!(parseInt(layer.data.features[objectIndex].properties.id.substring(1)) === this.ficheObjetObjectID))) {
                objectIndex--;
            }
            let object = layer.data.features[objectIndex];

            let coordinates = geom.split(",");
            if (object.properties.type_geom === "ST_Point") {
                object.geometry = { type: "Point", coordinates: [parseFloat(coordinates[0]), parseFloat(coordinates[1])] };
            } else if (object.properties.type_geom === "ST_Linestring") {
                object.geometry = { type: "LineString", coordinates: [] };
                for (let i = 0; i < coordinates.length / 2; i++) {
                    object.geometry.coordinates.push([parseFloat(coordinates[2 * i]), parseFloat(coordinates[2 * i + 1])]);
                }
            } else if (object.properties.type_geom === "ST_Polygon") {
                object.geometry = { type: "Polygon", coordinates: [[]] };
                for (let i = 0; i < coordinates.length / 2; i++) {
                    object.geometry.coordinates[0].push([parseFloat(coordinates[2 * i]), parseFloat(coordinates[2 * i + 1])]);
                }
            }

            if (object.properties.offline_status) {
                ;
            } else {
                object.properties.offline_status = 'object_modified';
            }
            console.log('editGeom result : ', object);

            await sysmaLayersDB.put('layers', layer);

            this.showParametersForm = false;
            this.showCreateObjectForm = false;
            this.showCorrigerFicheObjet = false;
            this.showFicheObjet = true;

            // document.getElementById("layerobjecttype" + this.ficheObjetObjectID + "LayerController").click();
            // document.getElementById("layerobjecttype" + this.ficheObjetObjectID + "LayerController").click();
        },



        /******************************
         * Makes the buttons GeoNewButton of the layermanager appear and GeoCancelButton disappear after creating an object
         ******************************/
        toggleLayerManagerButtons() {
            let geoNewButtonStyle = document.getElementsByClassName('o' + this.creerObjetObjectTypeID + 'GeoNewButton btn btn-default btn-xs')[0].style;
            geoNewButtonStyle.display = "inline-block";
            let geoCancelButtonStyle = document.getElementsByClassName('o' + this.creerObjetObjectTypeID + 'GeoCancelButton btn btn-default btn-xs')[0].style;
            geoCancelButtonStyle.display = "none";
        },



        /******************************
         * Function that gets the necessary data in IndexedDB and makes the Fiche objet appear
         * 
         * ATTENTION POURL'INSTANT LE CAS OU L'OBJET RECHERCH2 N'EST PAS DANS LA COUCHE N'EST PAS PRIS EN COMPTE CE QUI PEUT
         * AMMENER A DE POTENTIELLES ERREURES
         ******************************/
        async ficheObjet() {
            const sysmaAppStateDB = await openDB('sysmaAppStateDB');
            let isOffline = (await sysmaAppStateDB.get('state', 'isOffline')).value;

            if (isOffline) {

                const sysmaLayersDB = await openDB('sysmaLayersDB');
                let layer = await sysmaLayersDB.get('layers', this.ficheObjetObjectTypeID);

                let i = 0;
                while (i < layer.data.features.length && (!(parseInt(layer.data.features[i].properties.id.substring(1)) === this.ficheObjetObjectID))) {
                    // console.log(parseInt(layer.data.features[i].properties.id.substring(1)));
                    i++;
                }
                if (i === layer.data.features.length) {
                    this.ficheObjetFeature = null;
                } else {
                    this.ficheObjetFeature = layer.data.features[i];

                    let offlineInitData = (await sysmaAppStateDB.get('state', 'offlineInitData')).value;
                    for (let org of offlineInitData.orgLabels) {
                        if (org.organisation_id.toString() === this.ficheObjetFeature.properties.organisation_id.toString()) {
                            this.sysmaOrgLabel = org.acronym;
                        } else {
                            ;
                        }
                    }
                }

                const sysmaDictDB = await openDB('sysmaDictDB');
                this.ficheObjetThesaurus = (await sysmaDictDB.get('dictionnaires', this.ficheObjetObjectTypeID)).data;

                this.showParametersForm = false;
                this.showCreateObjectForm = false;
                this.showCorrigerFicheObjet = false;
                this.showFicheObjet = true;
            } else {
                ;
            }
        },



        /******************************
         * Fonction qui extrait d'un dictionnaire Sysma les données nécessaires à l'élaboration
         * d'un formulaire offline.
         * 
         * @param {Object} jsonThesaurus un dictionnaire Sysma
         * @returns une liste d'objets représentant les attributs du type objet concerné
         ******************************/
        extractFromThesaurus(jsonThesaurus) {
            let result = [];
            let dico = jsonThesaurus.paramArray;
            for (const attribute of dico) {
                let att = {};
                att.type = attribute.data_type;
                att.id = attribute.parameter_id + '_paramInput';
                att.name = attribute.parameter_id + '_paramInput';
                att.label = attribute.parameter;
                att.time_tracking = attribute.time_tracking;
                if (att.type === 'textChoiceType') {
                    let options = [];
                    options.push({
                        optionValue: null,
                        optionName: 'Non renseigné',
                        selected: true
                    });
                    for (const i of Object.keys(attribute.choicesArray)) {
                        let option = {};
                        option.optionValue = attribute.choicesArray[i].nom;
                        option.optionName = attribute.choicesArray[i].nom;
                        option.selected = false;
                        options.push(option);
                    };
                    att.options = options;
                };
                if (att.type === 'multipleTextChoiceType') {
                    let options = [];
                    for (const i of Object.keys(attribute.choicesArray)) {
                        options.push({ 'optionName': attribute.choicesArray[i].nom, 'optionLabel': attribute.choicesArray[i].nom, 'optionID': attribute.choicesArray[i].choice_id });
                    };
                    att.options = options;
                }
                if (att.type === 'booleanType') {
                    let options = [{ optionValue: '', optionName: 'Non renseigné', selected: true },
                                { optionValue: '1', optionName: 'Oui', selected: false },
                                { optionValue: '0', optionName: 'Non', selected: false }];
                    att.options = options;
                }
                result.push(att);
            };
            // console.log(result);
            return result;
        },

        /******************************
         * Function similar to extractFromThesaurus but which initializes the inputs to their values that are
         * in the layer's geoJSON to allow the user to both give a value to an object's parameters and to correct their values.
         ******************************/
        async initializeTabMode() {
            let findIndex = (paramID, parameters) => {
                let i = 0;
                while (!(parameters[i].id.toString() === paramID.toString())) {
                    i++;
                }
                return i;
            }

            let formArray = this.extractFromThesaurus(this.ficheObjetThesaurus);

            if (this.ficheObjetFeature.properties.parameters) {
                for (const formItem of formArray) {
                    let paramIndex = findIndex(formItem.id.substring(0,formItem.id.length-11), this.ficheObjetFeature.properties.parameters);
                    if (formItem.type === "textType" || formItem.type === "longTextType" || formItem.type === "integerType" || formItem.type === "floatType") {
                        formItem.parameterValue = this.ficheObjetFeature.properties.parameters[paramIndex].value;
                    }
                    if (formItem.type === "textChoiceType") {
                        let textChoiceTypeValue = this.ficheObjetFeature.properties.parameters[paramIndex].value;
                        if (textChoiceTypeValue) {
                            for (const option of formItem.options) {
                                option.selected = (option.optionValue === textChoiceTypeValue);
                            }
                        } else { formItem.parameterValue = null; }
                    }
                    if (formItem.type === "multipleTextChoiceType") {
                        let textChoiceTypeValue = this.ficheObjetFeature.properties.parameters[paramIndex].value;
                        if (textChoiceTypeValue) {
                            for (const option of formItem.options) {
                                option.isSelected = (textChoiceTypeValue.includes(option.optionName));
                            }
                        }
                    }
                    if (formItem.type === "booleanType") {
                        let textChoiceTypeValue = this.ficheObjetFeature.properties.parameters[paramIndex].value;
                        if (textChoiceTypeValue === "1") {
                            formItem.options[0].selected = false;
                            formItem.options[1].selected = true;
                        } else if (textChoiceTypeValue === "0") {
                            formItem.options[0].selected = false;
                            formItem.options[2].selected = true;
                        }
                    }
                }
            }

            this.inputsListParametersForm = formArray;
            this.showFicheObjet = false;
            this.showCreateObjectForm = false;
            this.showCorrigerFicheObjet = false;
            this.showParametersForm = true;
        }
    },

    // async created() {
        // let url = window.location.origin + '/layeridsnames';
        // await fetch(url)
        //     .then(response => { return response.json() })
        //     .then(data => { this.objectTypesList = data; });
    // }
}

</script>

<template>

<!-- BOUTON FERMER DE RIGHT CONTENT (EN OFFLINE) -->
    <div v-if="!showCorrigerFicheObjet" class="text-right" style="margin-bottom:-35px;">
        <a id="sheetCloseButton"
        onclick="openClose('rightColumn', '40%', 'map', '60%');
        $('#infos').show(150);
        $('#offline-right-vue-content').hide(150);
        history.pushState(null, null, '/carte');
        drawnItems.clearLayers();" href="#" class="btn btn-default"
        @click="if (showParametersForm) {showParametersForm = false;}; createObjectFormValues = {}; parametersFormValues = {};">
            <span class="glyphicon glyphicon-remove"></span>
            Fermer
        </a>
    </div>
<!-- --- --- --- --- --- -->


<!-- CORRECTION DE LA FICHE OBJET ET DE LA GEOMETRIE -->
    <div v-if="showCorrigerFicheObjet" class="text-right" style="margin-bottom:-35px;">
        <a href="#" class="btn btn-default" id="backBtn" @click="showCorrigerFicheObjet = false; showFicheObjet = true;">
            <span class="glyphicon glyphicon-chevron-left"></span>
            Retour
        </a>
    </div>

    <h2 v-if="showCorrigerFicheObjet">Correction de l'objet {{ ficheObjetObjectID }} {{
        ficheObjetFeature.properties.name }} </h2>
    <p v-if="showCorrigerFicheObjet">Attention les données seront corrigées, les anciennes données seront écrasées.</p>
    <formGenerator v-if="showCorrigerFicheObjet" formID="formCorrectionFicheObjet" :formItemsList="inputsListCorrigerFicheObjetForm"
        :formValues="createObjectFormValues" :tabMode="false" />
    <br v-if="showCorrigerFicheObjet">
    <!-- Uncomment the following line in order to see the data entered in the form -->
    <!-- <h3 v-if="showCorrigerFicheObjet">{{ createObjectFormValues }}</h3> -->
    <button v-if="showCorrigerFicheObjet" id="objectCorrectionSubmitBtn" class="btn btn-xs btn-primary"
        @click="modifieFicheObjet">
        Corriger
    </button>

    <h2 v-if="showCorrigerFicheObjet">Correction du tracé</h2>
    <p v-if="showCorrigerFicheObjet">Cliquez sur le bouton "Commencer la modification" ci-dessous, puis déplacez les
        points du tracé de l'objet. Vous pouvez prolonger l'objet avec Ctrl+clic sur le premier ou dernier point. Une
        fois terminé, cliquez sur "Terminer le tracé".</p>
    <!-- <button v-if="showCorrigerFicheObjet" id="oGeoEditButton" href="#" onclick="console.log(map); $('.oGeoEditButtons').css('display', 'inline'); $('#oGeoEditButton').css('display', 'none'); loadFeature('o' + document.getElementById('fiche-objet-id').getAttribute('value'), 'ST_Point');" class="btn btn-xs btn-primary" style="display: inline;"><span class="glyphicon glyphicon-move"></span> Commencer la modification du tracé</button> -->
    <button v-if="showCorrigerFicheObjet" id="oGeoEditButton" href="#"
        onclick="console.log(map); console.log('o' + document.getElementById('fiche-objet-id').getAttribute('value')); $('.oGeoEditButtons').css('display', 'inline'); $('#oGeoEditButton').css('display', 'none'); loadFeature('o' + document.getElementById('fiche-objet-id').getAttribute('value'), 'ST_Point');"
        class="btn btn-xs btn-primary" style="display: inline;">
        <span class="glyphicon glyphicon-move"></span>
        Commencer la modification du tracé
    </button>
    <div v-if="showCorrigerFicheObjet" class="oGeoEditButtons" style="display: none;">
        <!-- The function saveFeature is replaced by the instructions in the onclick attribute -->
        <button id="oGeoSaveButton" href="#" class="btn btn-xs btn-success"
            onclick="map._layers['o' + document.getElementById('fiche-objet-id').getAttribute('value')].disableEdit(); document.getElementById('geoEditGeomData').setAttribute('value', JSON.parse(JSON.stringify(map._layers['o' + document.getElementById('fiche-objet-id').getAttribute('value')].toGeoJSON())).geometry.coordinates); map.editTools.stopDrawing(); drawnItems.clearLayers(); document.getElementById('geoEditGeomData').click(); $('.oGeoEditButtons').css('display', 'none'); $('#oGeoEditButton').css('display','inline');refreshLayer('objecttype',document.getElementById('fiche-objet-type-id').value, null);">
            Terminer le tracé
        </button>
        ou
        <!-- <button id="oGeoCancelButton" href="#" onclick="cancelGeoEditFeature('o' + document.getElementById('fiche-objet-id').getAttribute('value'), document.getElementById('fiche-objet-type-id').getAttribute('value')); $('.oGeoEditButtons').css('display', 'none'); $('#oGeoEditButton').css('display', 'inline');" class="btn btn-xs btn-default">
            Annuler
        </button> -->
        <button id="oGeoCancelButton" href="#"
            onclick="var snap = null; map._layers['o' + document.getElementById('fiche-objet-id').getAttribute('value')].disableEdit(); $('.oGeoEditButtons').css('display', 'none'); $('#oGeoEditButton').css('display', 'inline');"
            class="btn btn-xs btn-default">
            Annuler
        </button>
        <!-- cancelGeoEditFeature('o130432', '102547');$('.o130432GeoEditButtons').css('display', 'none');$('#o130432GeoEditButton').css('display', 'inline'); -->
    </div>
    <input v-show="false" id="geoEditGeomData" value="" @click="editGeometry" />
<!-- --- --- --- --- --- -->



<!-- CREATE OBJECT FORM -->
    <h1 v-if="showCreateObjectForm">Création d'un objet</h1>
    <!-- <button id="button1" @click="showCreateObjectForm = !showCreateObjectForm; initializeCreateObjectForm();">Montrer / Cacher</button> -->
    <formGenerator v-if="showCreateObjectForm" formID="createObjectForm" :formItemsList="inputsListCreateObjectForm" :formValues="createObjectFormValues"
        :tabMode="false" />
    <br v-if="showCreateObjectForm">
    <!-- Uncomment the following line in order to see the data entered in the form -->
    <!-- <h3 v-if="showCreateObjectForm">{{ createObjectFormValues }}</h3> -->

    <button v-if="showCreateObjectForm" id="objectSheetCreateButton" href="#" class="btn btn-primary" @click="createObject(); showCreateObjectForm = false;
    toggleLayerManagerButtons();" onclick="drawnItems.clearLayers();">
        Créer
    </button>
<!-- --- --- --- --- --- -->



<!-- PARAMETERS FORM (TAB MODE) -->
    <h1 v-if="showParametersForm">{{ ficheObjetFeature.properties.name }}
        <small><small>[{{ficheObjetObjectID}}]</small></small></h1>

    <div v-if="showParametersForm" id="blockDonnees">
        <div class="renseigneFormInside">
            <formGenerator v-if="showParametersForm && inputsListParametersForm" formID="parametersFormTabMode"
                :formItemsList="inputsListParametersForm" :formValues="parametersFormValues" :tabMode="true" />
        </div>
    </div>
    <br v-if="showParametersForm">
    <!-- Uncomment the following line in order to see the data entered in the form -->
    <!-- <h3 v-if="showParametersForm">{{ parametersFormValues }}</h3> -->

    <button v-if="showParametersForm" id="paramsSheetSubmitButton" href="#" class="btn btn-primary"
        @click="fillParameters(); showParametersForm = false; showCreateObjectForm = true;"
        onclick="openClose('rightColumn', '40%', 'map', '60%');$('#offline-right-vue-content').hide(150);$('#infos').show(150);">
        Renseigner
    </button>
<!-- --- --- --- --- --- -->



<!-- FICHE OBJET -->
    <ficheObjet v-if="showFicheObjet" :featureProperties="ficheObjetFeature.properties"
        :thesaurusObject="ficheObjetThesaurus" :sysmaOrgLabel="sysmaOrgLabel"
        @toggleToTabMode="initializeTabMode"
        @corrigerFicheObjet="initializeCorrigerFicheObjet" />
<!-- --- --- --- --- --- -->



    <!-- The following input elements exist in order to be able to get data from the external (regarding Vue)
    JS code. That means when we want Vue to be reactive when a value from external JS must trigger an action in Vue
    the developer should :
        1° put a $('#fiche-objet-id').attr('value', value) in the JS (or use getElementById)
        2° followed by a document.getElementById('fiche-objet-id').click()
    Then Vue is able to be reactive. -->
    <input v-show="false" id="fiche-objet-type-id" value="" @click="updateData();ficheObjet();" />
    <input v-show="false" id="fiche-objet-id" value="" @click="updateData" />
    <input v-show="false" id="creer-objet-type-id" value="" @click="updateData();initializeCreateObjectForm();" />

</template>